// Датчик температуры ds18b20 к 0 пину

#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <OneWire.h>
#include <DallasTemperature.h>

#define ONE_WIRE_BUS 0   // Датчик температуры ds18b20 к пину GPIO2
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

const char *ssid =  "1111";  // Имя вайфай точки доступа
const char *pass =  "1111"; // Пароль от точки доступа

const char *mqtt_server = "1111"; // Имя сервера MQTT
const int mqtt_port = 1883; // Порт для подключения к серверу MQTT
const char *mqtt_user = "1111"; // Логин от сервер
const char *mqtt_pass = "1111"; // Пароль от сервера

#define DEEP_SLEEP_S 600  // 600 s = 10 min.

ADC_MODE(ADC_VCC);

int i = 0;

int delta = 0;

float vccmin = 3.00;  // напряжение при котором отправляется сообщение в топик

float vcc = 0;

float temp = 0;

float temp2 = 0;

WiFiClient wclient;
PubSubClient client(wclient, mqtt_server, mqtt_port);

const uint32_t mark = 0x12345678;

extern "C" {
#include "user_interface.h"

  extern struct rst_info resetInfo;
}

void setup() {

  sensors.begin();
  Serial.begin(115200);
  delay(10);
  Serial.println();
  Serial.println();

}

void loop() {
  uint32_t cnt;
  uint32_t temp1;
  uint32_t f;

  ESP.rtcUserMemoryRead(0, &cnt, sizeof(cnt)); // читаем значение в ячейке 0 и присваиваем переменной cnt
  if ((cnt != mark) || (resetInfo.reason != REASON_DEEP_SLEEP_AWAKE)) {
    cnt = mark;
    temp1 = 0;
    ESP.rtcUserMemoryWrite(0, &cnt, sizeof(cnt));  // записываем в ячейку 0 значеие переменной cnt
    ESP.rtcUserMemoryWrite(2, &temp1, sizeof(temp1));  // записываем в ячейку 2 значеие переменной temp1
    cnt = 0;
    ESP.rtcUserMemoryWrite(1, &cnt, sizeof(cnt));  // записываем в ячейку 1 значеие переменной cnt
    f = 0;
    ESP.rtcUserMemoryWrite(3, &f, sizeof(f));  // записываем в ячейку 3 значеие переменной f

  }
  else {
    ESP.rtcUserMemoryRead(1, &cnt, sizeof(cnt)); // читаем значение в ячейке 1 и присваиваем переменной cnt
    ESP.rtcUserMemoryRead(2, &temp1, sizeof(temp1)); // читаем значение в ячейке 2 и присваиваем переменной temp1
    ESP.rtcUserMemoryRead(3, &f, sizeof(f)); // читаем значение в ячейке 3 и присваиваем переменной f
  }

  Serial.print("Temperatura: ");
  sensors.requestTemperatures();   // от датчика получаем значение температуры
  float temp = sensors.getTempCByIndex(0);
  if (temp < 0) {
    temp2 = temp * -1;
  }
  else temp2 = temp;
  Serial.println(temp);
  Serial.println(temp1);
  Serial.println(temp2);
  delta = temp1 - temp2 * 1000;
  if (delta < 0) {      // если дельта отрицательная, то преобразуем в положительную
    delta = delta * -1;
  }
  Serial.println(delta);
  Serial.println(cnt);
  if (cnt == 6 || delta >= 200 || f == 0) {
    if (f != 0) {
      deepsleep_ON();
    }
label: // подключаемся к wi-fi
    if (WiFi.status() != WL_CONNECTED) {
      Serial.print("Connecting to ");
      Serial.print(ssid);
      Serial.println("...");
      WiFi.begin(ssid, pass);

      if (WiFi.waitForConnectResult() != WL_CONNECTED) {
        i = i + 1;
        if (i != 3) {
          goto label;
        } else {
          i = 0;
          Serial.println("WiFi not connected");
          cnt = 1;
          ESP.rtcUserMemoryWrite(1, &cnt, sizeof(cnt));
          deepsleepOF();
        }
      } else {
        Serial.println("WiFi connected");
        i = 0;
      }
    }
labe2: // подключаемся к MQTT серверу
    if (WiFi.status() == WL_CONNECTED) {
      if (!client.connected()) {
        Serial.println("Connecting to MQTT server");
        if (client.connect(MQTT::Connect("arduinoClient2")
                           .set_auth(mqtt_user, mqtt_pass))) {
          Serial.println("Connected to MQTT server");
        } else {
          Serial.println("Could not connect to MQTT server");
          i = i + 1;
          if (i != 3) {
            goto labe2;
          } else {
            i = 0;
            cnt = 1;
            ESP.rtcUserMemoryWrite(1, &cnt, sizeof(cnt));
            deepsleepOF();
          }
        }
      }
      if (client.connected()) {
        client.loop();
        client.publish("Ulica/temp", String(temp)); // отправляем в топик для термодатчика значение температуры
        // измерение напряжения
        float vcc  = ESP.getVcc() / 1024.0;
        client.publish("Ulica/vcc", String(vcc)); // отправляем в топик для напряжения значение
        Serial.println(vcc);
        if (vcc <= vccmin) {   // если напряжение  батареи меньше или равно vccmin
          client.publish("Inform/mess", "Батарея = " + String(vcc) + " вольта!!!  "); // отправляем в топик
  //      client.publish("Inform/mess", "Требуется замена батареи!!!  "); // отправляем в топик
        }
        Serial.println(vcc);
      }
    }
    cnt = 0;
    temp1 = temp2 * 1000;
    ESP.rtcUserMemoryWrite(2, &temp1, sizeof(temp1));
  }
  cnt = ++cnt;
  ESP.rtcUserMemoryWrite(1, &cnt, sizeof(cnt));
  deepsleepOF();

} // конец основного цикла

// глубокий сон
void deepsleepOF() {
  client.disconnect();

  delay(500); // Необходимо правильно закрыть соединение.

  WiFi.disconnect();
  Serial.println("Going to deep sleep...");
  uint32_t f;
  f = 1;
  ESP.rtcUserMemoryWrite(3, &f, sizeof(f));
  ESP.deepSleep(DEEP_SLEEP_S * 1000 * 1000, WAKE_RF_DISABLED); //выключение радиомодуля после сна
}

void deepsleep_ON() {
  Serial.println("Going to deep sleep...ON");
  uint32_t f;
  f = 0;
  ESP.rtcUserMemoryWrite(3, &f, sizeof(f));
  ESP.deepSleep(DEEP_SLEEP_S / 10, WAKE_RF_DEFAULT); //включение радиомодуля после сна
}

